# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class CatalogV1Id(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, catalog_v1_id=None, location_id=None):
        """
        CatalogV1Id - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'catalog_v1_id': 'str',
            'location_id': 'str'
        }

        self.attribute_map = {
            'catalog_v1_id': 'catalog_v1_id',
            'location_id': 'location_id'
        }

        self._catalog_v1_id = catalog_v1_id
        self._location_id = location_id

    @property
    def catalog_v1_id(self):
        """
        Gets the catalog_v1_id of this CatalogV1Id.
        The ID for an object in Connect V1, if different from its Connect V2 ID.

        :return: The catalog_v1_id of this CatalogV1Id.
        :rtype: str
        """
        return self._catalog_v1_id

    @catalog_v1_id.setter
    def catalog_v1_id(self, catalog_v1_id):
        """
        Sets the catalog_v1_id of this CatalogV1Id.
        The ID for an object in Connect V1, if different from its Connect V2 ID.

        :param catalog_v1_id: The catalog_v1_id of this CatalogV1Id.
        :type: str
        """

        self._catalog_v1_id = catalog_v1_id

    @property
    def location_id(self):
        """
        Gets the location_id of this CatalogV1Id.
        The ID of the [location](#type-location) this Connect V1 ID is associated with.

        :return: The location_id of this CatalogV1Id.
        :rtype: str
        """
        return self._location_id

    @location_id.setter
    def location_id(self, location_id):
        """
        Sets the location_id of this CatalogV1Id.
        The ID of the [location](#type-location) this Connect V1 ID is associated with.

        :param location_id: The location_id of this CatalogV1Id.
        :type: str
        """

        self._location_id = location_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
