# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class CreateRefundResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, errors=None, refund=None):
        """
        CreateRefundResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'errors': 'list[Error]',
            'refund': 'Refund'
        }

        self.attribute_map = {
            'errors': 'errors',
            'refund': 'refund'
        }

        self._errors = errors
        self._refund = refund

    @property
    def errors(self):
        """
        Gets the errors of this CreateRefundResponse.
        Any errors that occurred during the request.

        :return: The errors of this CreateRefundResponse.
        :rtype: list[Error]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """
        Sets the errors of this CreateRefundResponse.
        Any errors that occurred during the request.

        :param errors: The errors of this CreateRefundResponse.
        :type: list[Error]
        """

        self._errors = errors

    @property
    def refund(self):
        """
        Gets the refund of this CreateRefundResponse.
        The created refund.

        :return: The refund of this CreateRefundResponse.
        :rtype: Refund
        """
        return self._refund

    @refund.setter
    def refund(self, refund):
        """
        Sets the refund of this CreateRefundResponse.
        The created refund.

        :param refund: The refund of this CreateRefundResponse.
        :type: Refund
        """

        self._refund = refund

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
