# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class CustomerPreferences(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, email_unsubscribed=None):
        """
        CustomerPreferences - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'email_unsubscribed': 'bool'
        }

        self.attribute_map = {
            'email_unsubscribed': 'email_unsubscribed'
        }

        self._email_unsubscribed = email_unsubscribed

    @property
    def email_unsubscribed(self):
        """
        Gets the email_unsubscribed of this CustomerPreferences.
        The customer has unsubscribed from receiving marketing campaign emails.

        :return: The email_unsubscribed of this CustomerPreferences.
        :rtype: bool
        """
        return self._email_unsubscribed

    @email_unsubscribed.setter
    def email_unsubscribed(self, email_unsubscribed):
        """
        Sets the email_unsubscribed of this CustomerPreferences.
        The customer has unsubscribed from receiving marketing campaign emails.

        :param email_unsubscribed: The email_unsubscribed of this CustomerPreferences.
        :type: bool
        """

        self._email_unsubscribed = email_unsubscribed

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
