# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class ListEmployeesRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, location_id=None, status=None, limit=None, cursor=None):
        """
        ListEmployeesRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'location_id': 'str',
            'status': 'str',
            'limit': 'int',
            'cursor': 'str'
        }

        self.attribute_map = {
            'location_id': 'location_id',
            'status': 'status',
            'limit': 'limit',
            'cursor': 'cursor'
        }

        self._location_id = location_id
        self._status = status
        self._limit = limit
        self._cursor = cursor

    @property
    def location_id(self):
        """
        Gets the location_id of this ListEmployeesRequest.
        Filter employees returned to only those that are associated with the specified location.

        :return: The location_id of this ListEmployeesRequest.
        :rtype: str
        """
        return self._location_id

    @location_id.setter
    def location_id(self, location_id):
        """
        Sets the location_id of this ListEmployeesRequest.
        Filter employees returned to only those that are associated with the specified location.

        :param location_id: The location_id of this ListEmployeesRequest.
        :type: str
        """

        self._location_id = location_id

    @property
    def status(self):
        """
        Gets the status of this ListEmployeesRequest.
        Specifies the EmployeeStatus to filter the employee by. See [EmployeeStatus](#type-employeestatus) for possible values

        :return: The status of this ListEmployeesRequest.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this ListEmployeesRequest.
        Specifies the EmployeeStatus to filter the employee by. See [EmployeeStatus](#type-employeestatus) for possible values

        :param status: The status of this ListEmployeesRequest.
        :type: str
        """

        self._status = status

    @property
    def limit(self):
        """
        Gets the limit of this ListEmployeesRequest.
        The number of employees to be returned on each page.

        :return: The limit of this ListEmployeesRequest.
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """
        Sets the limit of this ListEmployeesRequest.
        The number of employees to be returned on each page.

        :param limit: The limit of this ListEmployeesRequest.
        :type: int
        """

        self._limit = limit

    @property
    def cursor(self):
        """
        Gets the cursor of this ListEmployeesRequest.
        The token required to retrieve the specified page of results.

        :return: The cursor of this ListEmployeesRequest.
        :rtype: str
        """
        return self._cursor

    @cursor.setter
    def cursor(self, cursor):
        """
        Sets the cursor of this ListEmployeesRequest.
        The token required to retrieve the specified page of results.

        :param cursor: The cursor of this ListEmployeesRequest.
        :type: str
        """

        self._cursor = cursor

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
