# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class ListEmployeesResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, employees=None, cursor=None, errors=None):
        """
        ListEmployeesResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'employees': 'list[Employee]',
            'cursor': 'str',
            'errors': 'list[Error]'
        }

        self.attribute_map = {
            'employees': 'employees',
            'cursor': 'cursor',
            'errors': 'errors'
        }

        self._employees = employees
        self._cursor = cursor
        self._errors = errors

    @property
    def employees(self):
        """
        Gets the employees of this ListEmployeesResponse.
        List of employees returned from the request.

        :return: The employees of this ListEmployeesResponse.
        :rtype: list[Employee]
        """
        return self._employees

    @employees.setter
    def employees(self, employees):
        """
        Sets the employees of this ListEmployeesResponse.
        List of employees returned from the request.

        :param employees: The employees of this ListEmployeesResponse.
        :type: list[Employee]
        """

        self._employees = employees

    @property
    def cursor(self):
        """
        Gets the cursor of this ListEmployeesResponse.
        The token to be used to retrieve the next page of results.

        :return: The cursor of this ListEmployeesResponse.
        :rtype: str
        """
        return self._cursor

    @cursor.setter
    def cursor(self, cursor):
        """
        Sets the cursor of this ListEmployeesResponse.
        The token to be used to retrieve the next page of results.

        :param cursor: The cursor of this ListEmployeesResponse.
        :type: str
        """

        self._cursor = cursor

    @property
    def errors(self):
        """
        Gets the errors of this ListEmployeesResponse.
        Any errors that occurred during the request.

        :return: The errors of this ListEmployeesResponse.
        :rtype: list[Error]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """
        Sets the errors of this ListEmployeesResponse.
        Any errors that occurred during the request.

        :param errors: The errors of this ListEmployeesResponse.
        :type: list[Error]
        """

        self._errors = errors

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
