# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class RetrieveCatalogObjectResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, errors=None, object=None, related_objects=None):
        """
        RetrieveCatalogObjectResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'errors': 'list[Error]',
            'object': 'CatalogObject',
            'related_objects': 'list[CatalogObject]'
        }

        self.attribute_map = {
            'errors': 'errors',
            'object': 'object',
            'related_objects': 'related_objects'
        }

        self._errors = errors
        self._object = object
        self._related_objects = related_objects

    @property
    def errors(self):
        """
        Gets the errors of this RetrieveCatalogObjectResponse.
        The set of [Error](#type-error)s encountered.

        :return: The errors of this RetrieveCatalogObjectResponse.
        :rtype: list[Error]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """
        Sets the errors of this RetrieveCatalogObjectResponse.
        The set of [Error](#type-error)s encountered.

        :param errors: The errors of this RetrieveCatalogObjectResponse.
        :type: list[Error]
        """

        self._errors = errors

    @property
    def object(self):
        """
        Gets the object of this RetrieveCatalogObjectResponse.
        The [CatalogObject](#type-catalogobject)s returned.

        :return: The object of this RetrieveCatalogObjectResponse.
        :rtype: CatalogObject
        """
        return self._object

    @object.setter
    def object(self, object):
        """
        Sets the object of this RetrieveCatalogObjectResponse.
        The [CatalogObject](#type-catalogobject)s returned.

        :param object: The object of this RetrieveCatalogObjectResponse.
        :type: CatalogObject
        """

        self._object = object

    @property
    def related_objects(self):
        """
        Gets the related_objects of this RetrieveCatalogObjectResponse.
        A list of [CatalogObject](#type-catalogobject)s referenced by the object in the `object` field.

        :return: The related_objects of this RetrieveCatalogObjectResponse.
        :rtype: list[CatalogObject]
        """
        return self._related_objects

    @related_objects.setter
    def related_objects(self, related_objects):
        """
        Sets the related_objects of this RetrieveCatalogObjectResponse.
        A list of [CatalogObject](#type-catalogobject)s referenced by the object in the `object` field.

        :param related_objects: The related_objects of this RetrieveCatalogObjectResponse.
        :type: list[CatalogObject]
        """

        self._related_objects = related_objects

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
